﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;

namespace sdtext_port
{
    class Program
    {
        private static java.util.ArrayList fingerprints = new java.util.ArrayList();
        static void Main(string[] args)
        {

            //ikvm.runtime.Startup.addBootClassPathAssemby(Assembly.Load("sdtext.dll"));
            java.lang.Class clazz = typeof(sdtext.API);
            java.lang.Thread.currentThread().setContextClassLoader(clazz.getClassLoader());

            //create java objects to make the parameters cross platform  
            java.lang.Double min = new java.lang.Double(.1);
            java.lang.Double max = new java.lang.Double(.9);

            java.lang.Integer threshold = new java.lang.Integer(5);
            var sw = new Stopwatch();
            sw.Start();

            //create a class object of the API 
            sdtext.API sdtext = new sdtext.API();

            Console.WriteLine("********** Creating Dictionary **********");
            //create a dictionary for testing
            sdtext.createDictAndTrim(min, max, "../../../../doc/configuration_files/tokenizers_config.xml", "../../../../doc/input_files/federalist", "fed.dictionary", "OFF");


            Console.WriteLine("********** Creating Fingerprint **********");
            // Create a single fingerprint
            sdtext.createFingerprint("../../../../doc/input_files/federalist/1", "fed.dictionary", "C:/Users/clay/Desktop/fingerprints/fed1.fing", "OFF");

            Console.WriteLine("********** Comparing to directory ********** ");
            // Compare the single fingerprint to the directory
            sdtext.Results results = sdtext.cmpFingerprintToDirectory(threshold, "CosineSimilarityFingerprintMatcher",
                                          "C:/Users/clay/Desktop/fingerprints/fed1.fing", "../../../../doc/input_files/federalist", "fed.dictionary", "OFF");

            results.printResults();

            Console.WriteLine("********** Creating additional fingerprints **********");
            // Create other fingerprints
            for (int i = 2; i < 20; i++)
            {
                sdtext.createFingerprint("../../../../doc/input_files/federalist/" + i, "fed.dictionary", "C:/Users/clay/Desktop/fingerprints/fed" + i + ".fing", "OFF");
            }

            Console.WriteLine("********** Finding Fingeprints **********");
            //Get the list of fingerprint files
            ProcessDirectory("C:/Users/clay/Desktop/fingerprints/");

            Console.WriteLine("********** Comparing text to fingerprints********** ");
            //Compare some text to the fingerprints
            results = sdtext.cmpFingerprintFilesToText(threshold, "CosineSimilarityFingerprintMatcher", "space addict element royal regain express scene spain alien enigma bourbon polish groan violent demerit while ", "fed.dictionary", fingerprints, "OFF");

            results.printResults();

            sw.Stop();

            Console.Out.WriteLine("Elapsed Time: " + sw.Elapsed);
            Console.ReadKey();
        }

        // Process all files in the directory passed in, recurse on any directories  
        // that are found, and process the files they contain. 
        public static void ProcessDirectory(string targetDirectory)
        {
            // Process the list of files found in the directory. 
            string[] fileEntries = Directory.GetFiles(targetDirectory);

            foreach (string fileName in fileEntries)
                ProcessFile(fileName);

            // Recurse into subdirectories of this directory. 
            string[] subdirectoryEntries = Directory.GetDirectories(targetDirectory);
            foreach (string subdirectory in subdirectoryEntries)
                ProcessDirectory(subdirectory);
        }

        private static void ProcessFile(String fileName)
        {
            fingerprints.add(fileName);
        }
    }

}
