package sdtext;

import argparser.BooleanHolder;
import argparser.DoubleHolder;
import argparser.StringHolder;
import edu.georgetown.gucs.utility.SdTextException;

import java.util.Vector;

/**
 * @author Evan B.
 * @since 3/3/15
 *
 * C
 */
public abstract class Arguments {

    StringHolder input = new StringHolder();
    StringHolder output = new StringHolder();

    StringHolder dictionary = new StringHolder();
    StringHolder fingerprint = new StringHolder(); 
    StringHolder source = new StringHolder();  
    StringHolder target = new StringHolder();  


    StringHolder config = new StringHolder();
    StringHolder debug = new StringHolder();


    StringHolder directory = new StringHolder();
    StringHolder matcher = new StringHolder();

    DoubleHolder minIDF = new DoubleHolder();
    DoubleHolder maxIDF = new DoubleHolder();
    DoubleHolder minScore = new DoubleHolder();


   // BooleanHolder bool = new BooleanHolder();

    static void setLoggingLvl(String logLvl) throws SdTextException {}

    public String getInputSpec() {

        return "-i,--input %s #FileName to read for input";

    }

    public String getOutputSpec() {

        return "-o,--output %s #Filename to write output";
    }

    public String getDictionarySpec() {

        return "-d,--dictionary %s #Filename containing dictionary";
    }

    public String getFingerprintSpec() {

        return "-f, --fingerprint %s #Filename containing fingerprint";
    }

    public String getSourceSpec() {

        return "-g, --sourceFingerprint %s #Filename containing fingerprint";
    }


    public String getTargetSpec() {

        return "-t, --targetFingerprint %s #Filename containing fingerprint";
    }

    public String getConfigSpec() {

        return "-c, --config %s #Filename of configuration file";
    }

    public String getDebugSpec() {
        return "-q,--debug %s  #Specify level for logging to log named sdtext.log. Logging is off by default.";
    }


    public String getDirectorySpec() {
        return "-p, --directory %s #Path to a directory";
    }

    public String getMatcherSpec() {
        return "-m, --matcher %s #Name of matcher to use";
    }

    public String getMinIdfSpec() {
        return "-l, --min-idf %f {[0,1]} #minimum normalized IDF (0.0 - 1.0) to consider in dictionary, default = 0.0 ";
    }

    public String getMaxIdfSpec() {
        return "-h, --max-idf %f {[0,1]} #maximum normalized IDF (0.0 - 1.0) to consider in dictionary, default = 1.0 ";
    }

    public String getMinScore() {
        return "-s, --min-score %f {[0,100]} #minimum score (0-100) required for results to be output";
    }


}
